﻿package tests {
	
	import flash.geom.Point;
	import com.gskinner.performance.TestSuite;
	import com.gskinner.performance.MethodTest;
	
	public class LoopHoisting extends TestSuite {
		
	// Constants:
		
	// Public Properties:
		// the number of elements in each collection:
		public var loops:uint = 10000000;
		
	// Protected Properties:
		protected var arr:Array;
		
		// set up some variables used in the test:
		
	// Initialization:
		public function LoopHoisting() {
			name = "LoopHoisting";
			description = "Demonstration of loop invariant code motion / loop hoisting. "+loops+" loops.";
			initFunction = init;
			iterations = 4;
			tests = [
				new MethodTest(unhoisted, null, "unhoisted", 0, 1, "unhoisted"),
				new MethodTest(hoisted, null, "hoisted", 0, 1, "hoisted")
			];
		}
		
	// Public getter / setters:
		
	// Protected Methods:
		protected function init():void {
			arr = [];
			for (var i:uint=0; i<loops; i++) {
				arr[i] = i;
			}
		}
		
		protected function unhoisted():void {
			for (var i:uint=0; i<arr.length; i++) {
				
			}
		}
		
		protected function hoisted():void {
			var l:uint = arr.length;
			for (var i:uint=0; i<l; i++) {
			}
		}
		
	}
	
}